Package: org.codehaus.groovy.util

## [Java] Class ListHashMap<K, V>

- org.codehaus.groovy.util.ListHashMap

- All Implemented Interfaces and Traits:
    Map

      public class ListHashMap<K, V>
      extends Object
      implements Map

  Represents a Map that is optimized for a small number of entries. For a number of entries up to `listSize` the entries are stored in arrays. After `listSize` entries are exceeded storage switches internally to a Map and converts back to being array based when its size is less than or equal to `listSize`.

  Null keys or values are not supported.

  This class is not thread-safe!

- - ### Constructor Summary

    Constructors
    Constructor and description
    `ListHashMap()` Creates a map that keeps up to three entries in array-backed storage.
    `ListHashMap(int listSize)` Creates a map that keeps up to `listSize` entries in array-backed storage.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `clear()` Removes all of the mappings from this map (optional operation). The map will be empty after this call returns. throws: UnsupportedOperationException if the `clear` operation is not supported by this map
    `` | `public boolean` | `containsKey(Object key)` Returns `true` if this map contains a mapping for the specified key. More formally, returns `true` if and only if this map contains a mapping for a key `k` such that `Objects.equals(key, k)`. (There can be at most one such mapping.) throws: ClassCastException if the key is of an inappropriate type for this map (optional) throws: NullPointerException if the specified key is null and this map does not permit null keys (optional) Parameters: `key` - key whose presence in this map is to be tested Returns: `true` if this map contains a mapping for the specified key
    `` | `public boolean` | `containsValue(Object value)` Returns `true` if this map maps one or more keys to the specified value. More formally, returns `true` if and only if this map contains at least one mapping to a value `v` such that `Objects.equals(value, v)`. This operation will probably require time linear in the map size for most implementations of the `Map` interface. throws: ClassCastException if the value is of an inappropriate type for this map (optional) throws: NullPointerException if the specified value is null and this map does not permit null values (optional) Parameters: `value` - value whose presence in this map is to be tested Returns: `true` if this map maps one or more keys to the specified value
    `` | `public Set<Entry<K, V>>` | `entrySet()` Returns a Set view of the mappings contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own `remove` operation, or through the `setValue` operation on a map entry returned by the iterator) the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations. Returns: a set view of the mappings contained in this map
    `` | `public V` | `get(Object key)` Returns the value to which the specified key is mapped, or `null` if this map contains no mapping for the key. More formally, if this map contains a mapping from a key `k` to a value `v` such that `Objects.equals(key, k)`, then this method returns `v`; otherwise it returns `null`. (There can be at most one such mapping.) If this map permits null values, then a return value of `null` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `null`. The containsKey operation may be used to distinguish these two cases. throws: ClassCastException if the key is of an inappropriate type for this map (optional) throws: NullPointerException if the specified key is null and this map does not permit null keys (optional) Parameters: `key` - the key whose associated value is to be returned Returns: the value to which the specified key is mapped, or `null` if this map contains no mapping for the key
    `` | `public boolean` | `isEmpty()` Returns `true` if this map contains no key-value mappings. Returns: `true` if this map contains no key-value mappings
    `` | `public Set<K>` | `keySet()` Returns a Set view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own `remove` operation), the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations. Returns: a set view of the keys contained in this map
    `` | `public V` | `put(K key, V value)` Associates the specified value with the specified key in this map (optional operation). If the map previously contained a mapping for the key, the old value is replaced by the specified value. (A map `m` is said to contain a mapping for a key `k` if and only if containsKey(Object) m.containsKey(k) would return `true`.) throws: UnsupportedOperationException if the `put` operation is not supported by this map throws: ClassCastException if the class of the specified key or value prevents it from being stored in this map throws: NullPointerException if the specified key or value is null and this map does not permit null keys or values throws: IllegalArgumentException if some property of the specified key or value prevents it from being stored in this map Parameters: `key` - key with which the specified value is to be associated `value` - value to be associated with the specified key Returns: the previous value associated with `key`, or `null` if there was no mapping for `key`. (A `null` return can also indicate that the map previously associated `null` with `key`, if the implementation supports `null` values.)
    `` | `public void` | `putAll(Map<? extends K, ? extends V> m)` Copies all of the mappings from the specified map to this map (optional operation). The effect of this call is equivalent to that of calling put(Object,Object) put(k, v) on this map once for each mapping from key `k` to value `v` in the specified map. The behavior of this operation is undefined if the specified map is modified while the operation is in progress. throws: UnsupportedOperationException if the `putAll` operation is not supported by this map throws: ClassCastException if the class of a key or value in the specified map prevents it from being stored in this map throws: NullPointerException if the specified map is null, or if this map does not permit null keys or values, and the specified map contains null keys or values throws: IllegalArgumentException if some property of a key or value in the specified map prevents it from being stored in this map Parameters: `m` - mappings to be stored in this map
    `` | `public V` | `remove(Object key)` Removes the mapping for a key from this map if it is present (optional operation). More formally, if this map contains a mapping from key `k` to value `v` such that `Objects.equals(key, k)`, that mapping is removed. (The map can contain at most one such mapping.) Returns the value to which this map previously associated the key, or `null` if the map contained no mapping for the key. If this map permits null values, then a return value of `null` does not necessarily indicate that the map contained no mapping for the key; it's also possible that the map explicitly mapped the key to `null`. The map will not contain a mapping for the specified key once the call returns. throws: UnsupportedOperationException if the `remove` operation is not supported by this map throws: ClassCastException if the key is of an inappropriate type for this map (optional) throws: NullPointerException if the specified key is null and this map does not permit null keys (optional) Parameters: `key` - key whose mapping is to be removed from the map Returns: the previous value associated with `key`, or `null` if there was no mapping for `key`.
    `` | `public int` | `size()` Returns the number of key-value mappings in this map. If the map contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`. Returns: the number of key-value mappings in this map
    `` | `public Collection<V>` | `values()` Returns a Collection view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. If the map is modified while an iteration over the collection is in progress (except through the iterator's own `remove` operation), the results of the iteration are undefined. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations. Returns: a collection view of the values contained in this map

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### public ListHashMap()

      Creates a map that keeps up to three entries in array-backed storage.

    - #### public ListHashMap(int listSize)

      Creates a map that keeps up to `listSize` entries in array-backed storage.

      Parameters:
        `listSize` - the number of entries to keep in arrays before promoting to a backing map

  - ### Method Detail

    - #### public void clear()

      Removes all of the mappings from this map (optional operation). The map will be empty after this call returns.

      throws:
        UnsupportedOperationException if the `clear` operation is not supported by this map

    - #### public boolean containsKey(Object key)

      Returns `true` if this map contains a mapping for the specified key. More formally, returns `true` if and only if this map contains a mapping for a key `k` such that `Objects.equals(key, k)`. (There can be at most one such mapping.)

      throws:
        ClassCastException if the key is of an inappropriate type for this map (optional)
      throws:
        NullPointerException if the specified key is null and this map does not permit null keys (optional)
      Parameters:
        `key` - key whose presence in this map is to be tested
      Returns:
        `true` if this map contains a mapping for the specified key

    - #### public boolean containsValue(Object value)

      Returns `true` if this map maps one or more keys to the specified value. More formally, returns `true` if and only if this map contains at least one mapping to a value `v` such that `Objects.equals(value, v)`. This operation will probably require time linear in the map size for most implementations of the `Map` interface.

      throws:
        ClassCastException if the value is of an inappropriate type for this map (optional)
      throws:
        NullPointerException if the specified value is null and this map does not permit null values (optional)
      Parameters:
        `value` - value whose presence in this map is to be tested
      Returns:
        `true` if this map maps one or more keys to the specified value

    - #### public Set<Entry<K, V>> entrySet()

      Returns a Set view of the mappings contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own `remove` operation, or through the `setValue` operation on a map entry returned by the iterator) the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.

      Returns:
        a set view of the mappings contained in this map

    - #### public V get(Object key)

      Returns the value to which the specified key is mapped, or `null` if this map contains no mapping for the key.

      More formally, if this map contains a mapping from a key `k` to a value `v` such that `Objects.equals(key, k)`, then this method returns `v`; otherwise it returns `null`. (There can be at most one such mapping.)

      If this map permits null values, then a return value of `null` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `null`. The containsKey operation may be used to distinguish these two cases.

      throws:
        ClassCastException if the key is of an inappropriate type for this map (optional)
      throws:
        NullPointerException if the specified key is null and this map does not permit null keys (optional)
      Parameters:
        `key` - the key whose associated value is to be returned
      Returns:
        the value to which the specified key is mapped, or `null` if this map contains no mapping for the key

    - #### public boolean isEmpty()

      Returns `true` if this map contains no key-value mappings.

      Returns:
        `true` if this map contains no key-value mappings

    - #### public Set<K> keySet()

      Returns a Set view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own `remove` operation), the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

      Returns:
        a set view of the keys contained in this map

    - #### public V put(K key, V value)

      Associates the specified value with the specified key in this map (optional operation). If the map previously contained a mapping for the key, the old value is replaced by the specified value. (A map `m` is said to contain a mapping for a key `k` if and only if containsKey(Object) m.containsKey(k) would return `true`.)

      throws:
        UnsupportedOperationException if the `put` operation is not supported by this map
      throws:
        ClassCastException if the class of the specified key or value prevents it from being stored in this map
      throws:
        NullPointerException if the specified key or value is null and this map does not permit null keys or values
      throws:
        IllegalArgumentException if some property of the specified key or value prevents it from being stored in this map
      Parameters:
        `key` - key with which the specified value is to be associated
        `value` - value to be associated with the specified key
      Returns:
        the previous value associated with `key`, or `null` if there was no mapping for `key`. (A `null` return can also indicate that the map previously associated `null` with `key`, if the implementation supports `null` values.)

    - #### public void putAll(Map<? extends K, ? extends V> m)

      Copies all of the mappings from the specified map to this map (optional operation). The effect of this call is equivalent to that of calling put(Object,Object) put(k, v) on this map once for each mapping from key `k` to value `v` in the specified map. The behavior of this operation is undefined if the specified map is modified while the operation is in progress.

      throws:
        UnsupportedOperationException if the `putAll` operation is not supported by this map
      throws:
        ClassCastException if the class of a key or value in the specified map prevents it from being stored in this map
      throws:
        NullPointerException if the specified map is null, or if this map does not permit null keys or values, and the specified map contains null keys or values
      throws:
        IllegalArgumentException if some property of a key or value in the specified map prevents it from being stored in this map
      Parameters:
        `m` - mappings to be stored in this map

    - #### public V remove(Object key)

      Removes the mapping for a key from this map if it is present (optional operation). More formally, if this map contains a mapping from key `k` to value `v` such that `Objects.equals(key, k)`, that mapping is removed. (The map can contain at most one such mapping.)

      Returns the value to which this map previously associated the key, or `null` if the map contained no mapping for the key.

      If this map permits null values, then a return value of `null` does not necessarily indicate that the map contained no mapping for the key; it's also possible that the map explicitly mapped the key to `null`.

      The map will not contain a mapping for the specified key once the call returns.

      throws:
        UnsupportedOperationException if the `remove` operation is not supported by this map
      throws:
        ClassCastException if the key is of an inappropriate type for this map (optional)
      throws:
        NullPointerException if the specified key is null and this map does not permit null keys (optional)
      Parameters:
        `key` - key whose mapping is to be removed from the map
      Returns:
        the previous value associated with `key`, or `null` if there was no mapping for `key`.

    - #### public int size()

      Returns the number of key-value mappings in this map. If the map contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.

      Returns:
        the number of key-value mappings in this map

    - #### public Collection<V> values()

      Returns a Collection view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. If the map is modified while an iteration over the collection is in progress (except through the iterator's own `remove` operation), the results of the iteration are undefined. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.

      Returns:
        a collection view of the values contained in this map